XIncludeFile "init.pb"

Structure block
  X.l
  Y.l
  T.l
  S.l
EndStructure

Structure expl
  X.l
  Y.l
  XS.l
  YS.l
  Timer.l
  Color.l
EndStructure

NewList Block.block()
NewList Pix.expl()
NewList DontSetHere.expl()

Procedure.l WaitForSpeed()
  SpeedCounter + 1
  If SpeedCounter > PlayerSpeed
    SpeedCounter = 0
    ProcedureReturn 1
  EndIf
  ProcedureReturn 0
EndProcedure

Procedure RepoBlock()
  Block()\X = Random(39)*10
  Block()\Y = Random(29)*10
EndProcedure

Procedure DrawWindowBorder(BorderWidth.l)
  Box(0,0,WindowWidth(),BorderWidth,RGB(0,0,0))
  Box(0,0,BorderWidth,WindowHeight(),RGB(0,0,0))
  Box(WindowWidth()-BorderWidth,0,BorderWidth,WindowHeight())
  Box(0,WindowHeight()-BorderWidth,WindowWidth(),BorderWidth)
EndProcedure

Procedure AddBlock(X.l,Y.l,Timer.l,Sprite.l)
  AddElement(Block())
  Block()\X = X
  Block()\Y = Y
  Block()\T = Timer
  Block()\S = Sprite
  AddElement(DontSetHere())
  DontSetHere()\X = X
  DontSetHere()\Y = Y
EndProcedure

Procedure AddRandomBlock(Type)
  Repeat
  Random1 = Random(39)
  Random1 * 10
  Random2 = Random(29)
  Random2 * 10
  Redo = 0
  If CountList(DontSetHere()) > 0
    ResetList(DontSetHere())
    While NextElement(DontSetHere())
      If random1 = DontSetHere()\X
        If random2 = DontSetHere()\Y
          Redo = 1
        EndIf
      EndIf
    Wend
  EndIf
  Until Redo = 0
  AddBlock(Random1 ,Random2 ,-1,Type)
EndProcedure

Procedure MoveBlock(X.l,Y.l)
  ResetList(Block())
  While NextElement(Block())
    AddRandomBlock(2)
  Wend
EndProcedure

Procedure PixExpl(X.l,Y.l,ColorT.l)
  NumberOfPix + 1
  AddElement(Pix())
  Pix()\X = X+Random(10)
  Pix()\Y = Y+Random(10)
  Pix()\XS = Random(10)-5
  Pix()\YS = Random(10)-5
  Pix()\Timer = Random(40)+10
  RandomNumber = Random(1)
  If ColorT = 1
    If RandomNumber = 0
      Pix()\Color = RGB(0,255,0)
    Else
      Pix()\Color = RGB(0,128,0)
    EndIf
  ElseIf ColorT = 0
    If RandomNumber = 0
      Pix()\Color = RGB(255,255,0)
    Else
      Pix()\Color = RGB(128,128,0)
    EndIf
  EndIf
EndProcedure

Procedure UpdateBlocks()
  NOPP = 0
  If PlayerX < 0
    Die=1
  EndIf
  If PlayerX > 390
    Die=1
  EndIf
  If PlayerY < 0
    Die=1
  EndIf
  If PlayerY > 290
    Die=1
  EndIf
  ExamineKeyboard()
  If AbleToMove = 1
    If KeyboardPushed(#PB_Key_Up)
        PlayerDir = 1
    EndIf
    If KeyboardPushed(#PB_Key_Down)
        PlayerDir = 3
    EndIf
    If KeyboardPushed(#PB_Key_Left)
        PlayerDir = 4
    EndIf
    If KeyboardPushed(#PB_Key_Right)
        PlayerDir = 2
    EndIf
    If WaitForSpeedNumber = 1
      If PlayerDir = 1
        PlayerY - 10
      ElseIf PlayerDir = 2
        PlayerX + 10
      ElseIf PlayerDir = 3
        PlayerY + 10
      ElseIf PlayerDir = 4
        PlayerX - 10
    EndIf
    AddBlock(PlayerX,PlayerY,PlayerTail,1)
  EndIf
  EndIf
  ResetList(Block())
  While NextElement(Block())
    If Block()\T <> -1
      Block()\T - 1
      If Block()\T = 0
        DeleteElement(Block())
      EndIf
    EndIf
    DisplaySprite(Block()\S,Block()\X,Block()\Y)
    If Block()\S = 2
      If SpriteCollision(1,PlayerX,PlayerY,2,Block()\X,Block()\Y)
        Die = 1
      EndIf
    ElseIf Block()\S = 3
      NOPP + 1
      If SpriteCollision(1,PlayerX,PlayerY,3,Block()\X,Block()\Y)
        For X = 1 To 20
          PixExpl(Block()\X,Block()\Y,0)
        Next X
        DeleteElement(Block())
        TailPlus + 2
        PlayerTail = PlayerSpeed*(5+TailPlus)       
        PlayerScore + Random(10)+50
        *Old_Element = Block()  
        ResetList(Block()) 
        While NextElement(Block()) 
          If Block()\S = 1
            Block()\T + PlayerSpeed*(2)
          EndIf
        Wend
        ResetList(Block()) 
        ChangeCurrentElement(Block(), *Old_Element)
      EndIf
    EndIf
  Wend
  AddTailLength = 0
EndProcedure

Procedure HitSelfCheck()
  ResetList(Block())
  HitSelfCounter = 0
  While NextElement(Block())
    If Block()\X = PlayerX
      If Block()\Y = PlayerY
        HitSelfCounter + 1
      EndIf
    EndIf
  Wend
  If HitSelfCounter > 1
    Die = 1
  EndIf
EndProcedure

Procedure UpdatePix()
  If CountList(Pix()) > 0
    ResetList(Pix())
    While NextElement(Pix())
      Pix()\X + Pix()\XS
      Pix()\Y + Pix()\YS
      Box(Pix()\X,Pix()\Y,2,2,Pix()\Color)
      Pix()\Timer - 1
      If Pix()\Timer = 0
        DeleteElement(Pix())
        NumberOfPix - 1
      EndIf
    Wend
  EndIf
EndProcedure

Procedure SetupField()
  For X = 1 To NumberOfMemoryBlocks
    AddRandomBlock(2)
    If Block()\X = PlayerX
      RepoBlock()
    EndIf
  Next X
  For X = 1 To NumberOfPowerPixels
    AddRandomBlock(3)
    If Block()\X = PlayerX
      RepoBlock()
    EndIf
  Next X
EndProcedure

Procedure GetHighScore()
  OpenFile(0,"gah.ihavenobonz")
    HighScoreName = ReadString()
    HighScore.l = Val(ReadString())
  CloseFile(0)
EndProcedure

Procedure SetHighScore(Name.s,Score.l)
  CreateFile(0,"gah.ihavenobonz")
    WriteStringN(Name)
    WriteString(Str(Score))
  CloseFile(0)
EndProcedure

Procedure HighScore()
  GetHighScore()
  If PlayerScore > HighScore
    MessageRequester("Great Job!","New high score! - "+Str(PlayerScore))
    Name.s = InputRequester("Enter Nae", "Please enter you name", "") 
    SetHighScore(Name.s,PlayerScore)
  Else
    MessageRequester("Try Again...","No high score this time. - "+Str(PlayerScore))
  EndIf
  End
EndProcedure

Procedure ExplodeSnake()
  AbleToMove = 0
  If CountList(Block()) > 0
    ResetList(Block())
    While NextElement(Block())
      If Block()\S = 1
        For X = 1 To 10
          PixExpl(Block()\X,Block()\Y,1)
        Next X
        DeleteElement(Block())
      EndIf
    Wend
  EndIf
  If CountList(Pix()) = 0
    HighScore()
  EndIf
EndProcedure

Procedure Pause()
  ClearScreen(0,0,0)
    StartDrawing(ScreenOutput())
      Locate(200-(TextLength(":: Paused ::")/2),140)
      DrawingMode(1)
      FrontColor(255,255,255)
      DrawText(":: Paused ::")
    StopDrawing()
  FlipBuffers()
  ExamineKeyboard()
  If KeyboardReleased(#PB_Key_Escape)
    If Pause = 0
      Pause = 1
    Else
      Pause = 0
    EndIf
  EndIf
EndProcedure

Procedure Menu()
  Repeat
    event = WindowEvent() 
    If event=#PB_Event_CloseWindow
      End
    EndIf
    ClearScreen(0,0,0)
      PixExpl(Random(400),Random(300),Random(1))
      PixExpl(Random(400),Random(300),Random(1))
      PixExpl(Random(400),Random(300),Random(1))
      StartDrawing(ScreenOutput())
        DrawWindowBorder(3)
        UpdatePix()
      StopDrawing()
      DisplaySprite(4,10,150-(SpriteHeight(4)/2))
    FlipBuffers()
    ExamineKeyboard()
  Until KeyboardPushed(#PB_Key_Space)
EndProcedure

Procedure StartNextLevel()

PlayerX = 190
PlayerY = 190
PlayerTail = PlayerSpeed*(5)+TailPlus
SpeedCounter = PlayerSpeed
AbleToMove = 1
NumberOfMemoryBlocks = 5+MemoryBlockAdd
NumberOfPowerPixels = 10+PowerPixelAdd
SnakeETimer = 0
GetHighScore()

SetupField()

ClearScreen(0,0,128)
UpdateBlocks()
StartDrawing(WindowOutput())
  DrawWindowBorder(3)
StopDrawing()
StartDrawing(ScreenOutput())
  Locate(200-(TextLength("Get Ready!")/2),140)
  DrawingMode(1)
  FrontColor(255,255,255)
  DrawText("Get Ready!")
StopDrawing()
DisplaySprite(1,PlayerX,PlayerY-10)
FlipBuffers()
Delay(1500)

PlayerDir = 1
If CountList(Pix()) > 0
  ResetList(Pix())
  While NextElement(Pix())
    DeleteElement(Pix())
  Wend
EndIf
Repeat
  If Pause = 1
    Pause()
  Else
  WaitForSpeedNumber = WaitForSpeed()
  ClearScreen(0,0,128)
  
  UpdateBlocks()
  HitSelfCheck()
  
  StartDrawing(WindowOutput())
    DrawWindowBorder(3)
  StopDrawing()
  StartDrawing(ScreenOutput())
    UpdatePix()
  StopDrawing()
    
  FlipBuffers()
  ExamineKeyboard()
  SpacesN = 10 - Len(Str(PlayerScore))
  Spaces.s = ""
  For X = 1 To SpacesN
    Spaces = Spaces + " "
  Next X
  SetGadgetText(0,"Score: " + Str(PlayerScore)+Spaces+"High Score: "+Str(HighScore)+" - "+HighScoreName)
  If KeyboardReleased(#PB_Key_Escape)
    If Pause = 0
      Pause = 1
    Else
      Pause = 0
    EndIf
  EndIf
  If DIE = 1
    ExplodeSnake()
  EndIf
  
  BkLoop = 0
  If NOPP = 0
    BkLoop = 1
  EndIf
  
  event = WindowEvent() 
  If event=#PB_Event_CloseWindow
    End
  EndIf
  EndIf
Until BkLoop = 1
    MemoryBlockAdd + 2
    PowerPixelAdd + 2
    TailPlus + 2
    SpeedAddCounter + 1
    If SpeedAddCounter = 3
      PlayerSpeed - 1
    EndIf
    ResetList(Block())
    While NextElement(Block())
      DeleteElement(Block())
    Wend
EndProcedure
; ExecutableFormat=Windows
; EOF